/*  GREATIS FORM DESIGNER FOR .NET           */
/*  Copyright (C) 2004-2014 Greatis Software */
/*  http://www.greatis.com/dotnet/formdes/   */
/*  http://www.greatis.com/bteam.html        */

using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Drawing;
using System.IO;
using System.Windows.Forms;

namespace FrameworkCS
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class DesignerDemo : System.Windows.Forms.Form
	{

		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem miNewForm;
		private System.Windows.Forms.MenuItem miOpenForm;
		private System.Windows.Forms.MenuItem miSaveForm;
		private System.Windows.Forms.MenuItem miExitDesigner;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem miDesign;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem miAbout;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem menuItem12;
		private System.Windows.Forms.MenuItem miAlignTop;
		private System.Windows.Forms.MenuItem miAlignMiddle;
		private System.Windows.Forms.MenuItem miAlignBottom;
		private System.Windows.Forms.MenuItem miAlignLeft;
		private System.Windows.Forms.MenuItem miAlignCenter;
		private System.Windows.Forms.MenuItem miAlignRight;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem miSameHeight;
		private System.Windows.Forms.MenuItem miSameWidth;
		private System.Windows.Forms.MenuItem menuItem13;
		private System.Windows.Forms.MenuItem miSameBoth;
		private System.Windows.Forms.MenuItem miDeleteSelection;

		private System.Windows.Forms.ToolBar mainToolBar;
		private System.Windows.Forms.ToolBarButton tbNewForm;
		private System.Windows.Forms.ToolBarButton tbOpenForm;
		private System.Windows.Forms.ToolBarButton tbSep1;
		private System.Windows.Forms.ToolBarButton tbSaveForm;
		private System.Windows.Forms.ToolBarButton tbSep2;
		private System.Windows.Forms.ToolBarButton tbDesign;
		private System.Windows.Forms.ToolBarButton tbSep3;
		private System.Windows.Forms.ToolBarButton tbAlignBottom;
		private System.Windows.Forms.ToolBarButton tbAlignTop;
		private System.Windows.Forms.ToolBarButton tbSep4;
		private System.Windows.Forms.ToolBarButton tbAlignLeft;
		private System.Windows.Forms.ToolBarButton tbAlignRight;
		private System.Windows.Forms.ToolBarButton tbAlignMiddle;
		private System.Windows.Forms.ToolBarButton tbAlignCenter;
		private System.Windows.Forms.ToolBarButton tbSep5;
		private System.Windows.Forms.ToolBarButton tbSameWidth;
		private System.Windows.Forms.ToolBarButton tbSameHeight;
		private System.Windows.Forms.ToolBarButton tbSameBoth;

		private System.Windows.Forms.ImageList mainToolBarImages;

		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.MenuItem miCopy;
		private System.Windows.Forms.MenuItem miPaste;
		private System.Windows.Forms.MenuItem menuItem14;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.MenuItem miUndo;
		private System.Windows.Forms.MenuItem miRedo;
		private Greatis.FormDesigner.Designer designer1;
		private Greatis.FormDesigner.Treasury treasury1;
		private ToolboxControl toolboxControl;
		private PropertyGrid propertyGrid;
		private Splitter splitter1;
		private Splitter splitter2;
		private Panel panelDesign;

		public DesignerDemo()
		{

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//return;

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			Init();
			InitDesignerMenu();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			propertyGrid.Dispose();

			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(DesignerDemo));
			this.mainMenu = new System.Windows.Forms.MainMenu(this.components);
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.miNewForm = new System.Windows.Forms.MenuItem();
			this.miOpenForm = new System.Windows.Forms.MenuItem();
			this.miSaveForm = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.miExitDesigner = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.miDesign = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.miUndo = new System.Windows.Forms.MenuItem();
			this.miRedo = new System.Windows.Forms.MenuItem();
			this.menuItem11 = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.miAlignTop = new System.Windows.Forms.MenuItem();
			this.miAlignMiddle = new System.Windows.Forms.MenuItem();
			this.miAlignBottom = new System.Windows.Forms.MenuItem();
			this.menuItem12 = new System.Windows.Forms.MenuItem();
			this.miAlignLeft = new System.Windows.Forms.MenuItem();
			this.miAlignCenter = new System.Windows.Forms.MenuItem();
			this.miAlignRight = new System.Windows.Forms.MenuItem();
			this.menuItem9 = new System.Windows.Forms.MenuItem();
			this.miSameHeight = new System.Windows.Forms.MenuItem();
			this.miSameWidth = new System.Windows.Forms.MenuItem();
			this.menuItem13 = new System.Windows.Forms.MenuItem();
			this.miSameBoth = new System.Windows.Forms.MenuItem();
			this.menuItem14 = new System.Windows.Forms.MenuItem();
			this.miCopy = new System.Windows.Forms.MenuItem();
			this.miPaste = new System.Windows.Forms.MenuItem();
			this.miDeleteSelection = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.miAbout = new System.Windows.Forms.MenuItem();
			this.mainToolBar = new System.Windows.Forms.ToolBar();
			this.tbNewForm = new System.Windows.Forms.ToolBarButton();
			this.tbOpenForm = new System.Windows.Forms.ToolBarButton();
			this.tbSep1 = new System.Windows.Forms.ToolBarButton();
			this.tbSaveForm = new System.Windows.Forms.ToolBarButton();
			this.tbSep2 = new System.Windows.Forms.ToolBarButton();
			this.tbDesign = new System.Windows.Forms.ToolBarButton();
			this.tbSep3 = new System.Windows.Forms.ToolBarButton();
			this.tbAlignBottom = new System.Windows.Forms.ToolBarButton();
			this.tbAlignMiddle = new System.Windows.Forms.ToolBarButton();
			this.tbAlignTop = new System.Windows.Forms.ToolBarButton();
			this.tbSep4 = new System.Windows.Forms.ToolBarButton();
			this.tbAlignLeft = new System.Windows.Forms.ToolBarButton();
			this.tbAlignCenter = new System.Windows.Forms.ToolBarButton();
			this.tbAlignRight = new System.Windows.Forms.ToolBarButton();
			this.tbSep5 = new System.Windows.Forms.ToolBarButton();
			this.tbSameWidth = new System.Windows.Forms.ToolBarButton();
			this.tbSameHeight = new System.Windows.Forms.ToolBarButton();
			this.tbSameBoth = new System.Windows.Forms.ToolBarButton();
			this.mainToolBarImages = new System.Windows.Forms.ImageList(this.components);
			this.designer1 = new Greatis.FormDesigner.Designer();
			this.treasury1 = new Greatis.FormDesigner.Treasury();
			this.panelDesign = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.propertyGrid = new System.Windows.Forms.PropertyGrid();
			this.toolboxControl = new FrameworkCS.ToolboxControl();
			this.SuspendLayout();
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem1,
            this.menuItem2,
            this.menuItem4});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miNewForm,
            this.miOpenForm,
            this.miSaveForm,
            this.menuItem6,
            this.miExitDesigner});
			this.menuItem1.Text = "&File";
			// 
			// miNewForm
			// 
			this.miNewForm.Index = 0;
			this.miNewForm.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
			this.miNewForm.Text = "&New";
			this.miNewForm.Click += new System.EventHandler(this.miNewForm_Click);
			// 
			// miOpenForm
			// 
			this.miOpenForm.Index = 1;
			this.miOpenForm.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.miOpenForm.Text = "&Open";
			this.miOpenForm.Click += new System.EventHandler(this.miOpenForm_Click);
			// 
			// miSaveForm
			// 
			this.miSaveForm.Index = 2;
			this.miSaveForm.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.miSaveForm.Text = "&Save";
			this.miSaveForm.Click += new System.EventHandler(this.miSaveForm_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 3;
			this.menuItem6.Text = "-";
			// 
			// miExitDesigner
			// 
			this.miExitDesigner.Index = 4;
			this.miExitDesigner.Text = "E&xit";
			this.miExitDesigner.Click += new System.EventHandler(this.miExitDesigner_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miDesign,
            this.menuItem7,
            this.miUndo,
            this.miRedo,
            this.menuItem11,
            this.menuItem8,
            this.menuItem9,
            this.menuItem14,
            this.miCopy,
            this.miPaste,
            this.miDeleteSelection});
			this.menuItem2.Text = "&Edit";
			// 
			// miDesign
			// 
			this.miDesign.Index = 0;
			this.miDesign.Text = "&End Design";
			this.miDesign.Click += new System.EventHandler(this.miDesign_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 1;
			this.menuItem7.Text = "-";
			// 
			// miUndo
			// 
			this.miUndo.Index = 2;
			this.miUndo.Text = "&Undo";
			this.miUndo.Click += new System.EventHandler(this.miUndo_Click);
			// 
			// miRedo
			// 
			this.miRedo.Index = 3;
			this.miRedo.Text = "&Redo";
			this.miRedo.Click += new System.EventHandler(this.miRedo_Click);
			// 
			// menuItem11
			// 
			this.menuItem11.Index = 4;
			this.menuItem11.Text = "-";
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 5;
			this.menuItem8.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miAlignTop,
            this.miAlignMiddle,
            this.miAlignBottom,
            this.menuItem12,
            this.miAlignLeft,
            this.miAlignCenter,
            this.miAlignRight});
			this.menuItem8.Text = "&Align";
			// 
			// miAlignTop
			// 
			this.miAlignTop.Index = 0;
			this.miAlignTop.Text = "&Top";
			this.miAlignTop.Click += new System.EventHandler(this.miAlignTop_Click);
			// 
			// miAlignMiddle
			// 
			this.miAlignMiddle.Index = 1;
			this.miAlignMiddle.Text = "&Middle";
			this.miAlignMiddle.Click += new System.EventHandler(this.miAlignMiddle_Click);
			// 
			// miAlignBottom
			// 
			this.miAlignBottom.Index = 2;
			this.miAlignBottom.Text = "&Bottom";
			this.miAlignBottom.Click += new System.EventHandler(this.miAlignBottom_Click);
			// 
			// menuItem12
			// 
			this.menuItem12.Index = 3;
			this.menuItem12.Text = "-";
			// 
			// miAlignLeft
			// 
			this.miAlignLeft.Index = 4;
			this.miAlignLeft.Text = "&Left";
			this.miAlignLeft.Click += new System.EventHandler(this.miAlignLeft_Click);
			// 
			// miAlignCenter
			// 
			this.miAlignCenter.Index = 5;
			this.miAlignCenter.Text = "&Center";
			this.miAlignCenter.Click += new System.EventHandler(this.miAlignCenter_Click);
			// 
			// miAlignRight
			// 
			this.miAlignRight.Index = 6;
			this.miAlignRight.Text = "&Right";
			this.miAlignRight.Click += new System.EventHandler(this.miAlignRight_Click);
			// 
			// menuItem9
			// 
			this.menuItem9.Index = 6;
			this.menuItem9.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miSameHeight,
            this.miSameWidth,
            this.menuItem13,
            this.miSameBoth});
			this.menuItem9.Text = "&Make Same";
			// 
			// miSameHeight
			// 
			this.miSameHeight.Index = 0;
			this.miSameHeight.Text = "Same &Height";
			this.miSameHeight.Click += new System.EventHandler(this.miSameHeight_Click);
			// 
			// miSameWidth
			// 
			this.miSameWidth.Index = 1;
			this.miSameWidth.Text = "Same &Width";
			this.miSameWidth.Click += new System.EventHandler(this.miSameWidth_Click);
			// 
			// menuItem13
			// 
			this.menuItem13.Index = 2;
			this.menuItem13.Text = "-";
			// 
			// miSameBoth
			// 
			this.miSameBoth.Index = 3;
			this.miSameBoth.Text = "Same &Both";
			this.miSameBoth.Click += new System.EventHandler(this.miSameBoth_Click);
			// 
			// menuItem14
			// 
			this.menuItem14.Index = 7;
			this.menuItem14.Text = "-";
			// 
			// miCopy
			// 
			this.miCopy.Index = 8;
			this.miCopy.Text = "&Copy";
			this.miCopy.Click += new System.EventHandler(this.miCopy_Click);
			// 
			// miPaste
			// 
			this.miPaste.Index = 9;
			this.miPaste.Text = "&Paste";
			this.miPaste.Click += new System.EventHandler(this.miPaste_Click);
			// 
			// miDeleteSelection
			// 
			this.miDeleteSelection.Index = 10;
			this.miDeleteSelection.Shortcut = System.Windows.Forms.Shortcut.Del;
			this.miDeleteSelection.Text = "&Delete";
			this.miDeleteSelection.Click += new System.EventHandler(this.miDeleteSelection_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.miAbout});
			this.menuItem4.Text = "&Help";
			// 
			// miAbout
			// 
			this.miAbout.Index = 0;
			this.miAbout.Text = "&About";
			this.miAbout.Click += new System.EventHandler(this.miAbout_Click);
			// 
			// mainToolBar
			// 
			this.mainToolBar.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.mainToolBar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
            this.tbNewForm,
            this.tbOpenForm,
            this.tbSep1,
            this.tbSaveForm,
            this.tbSep2,
            this.tbDesign,
            this.tbSep3,
            this.tbAlignBottom,
            this.tbAlignMiddle,
            this.tbAlignTop,
            this.tbSep4,
            this.tbAlignLeft,
            this.tbAlignCenter,
            this.tbAlignRight,
            this.tbSep5,
            this.tbSameWidth,
            this.tbSameHeight,
            this.tbSameBoth});
			this.mainToolBar.DropDownArrows = true;
			this.mainToolBar.ImageList = this.mainToolBarImages;
			this.mainToolBar.Location = new System.Drawing.Point(0, 0);
			this.mainToolBar.Name = "mainToolBar";
			this.mainToolBar.ShowToolTips = true;
			this.mainToolBar.Size = new System.Drawing.Size(738, 28);
			this.mainToolBar.TabIndex = 1;
			this.mainToolBar.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.mainToolBar_ButtonClick);
			// 
			// tbNewForm
			// 
			this.tbNewForm.ImageIndex = 0;
			this.tbNewForm.Name = "tbNewForm";
			this.tbNewForm.Tag = "";
			this.tbNewForm.ToolTipText = "New designed from";
			// 
			// tbOpenForm
			// 
			this.tbOpenForm.ImageIndex = 1;
			this.tbOpenForm.Name = "tbOpenForm";
			this.tbOpenForm.Tag = "";
			this.tbOpenForm.ToolTipText = "Open designed form";
			// 
			// tbSep1
			// 
			this.tbSep1.Name = "tbSep1";
			this.tbSep1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// tbSaveForm
			// 
			this.tbSaveForm.ImageIndex = 2;
			this.tbSaveForm.Name = "tbSaveForm";
			this.tbSaveForm.Tag = "";
			this.tbSaveForm.ToolTipText = "Save designed form";
			// 
			// tbSep2
			// 
			this.tbSep2.Name = "tbSep2";
			this.tbSep2.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// tbDesign
			// 
			this.tbDesign.ImageIndex = 3;
			this.tbDesign.Name = "tbDesign";
			this.tbDesign.Tag = "";
			this.tbDesign.ToolTipText = "Run edited form";
			// 
			// tbSep3
			// 
			this.tbSep3.Name = "tbSep3";
			this.tbSep3.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// tbAlignBottom
			// 
			this.tbAlignBottom.ImageIndex = 4;
			this.tbAlignBottom.Name = "tbAlignBottom";
			this.tbAlignBottom.ToolTipText = "Align bottom";
			// 
			// tbAlignMiddle
			// 
			this.tbAlignMiddle.ImageIndex = 8;
			this.tbAlignMiddle.Name = "tbAlignMiddle";
			this.tbAlignMiddle.ToolTipText = "Align middle";
			// 
			// tbAlignTop
			// 
			this.tbAlignTop.ImageIndex = 6;
			this.tbAlignTop.Name = "tbAlignTop";
			this.tbAlignTop.ToolTipText = "Align top";
			// 
			// tbSep4
			// 
			this.tbSep4.Name = "tbSep4";
			this.tbSep4.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// tbAlignLeft
			// 
			this.tbAlignLeft.ImageIndex = 7;
			this.tbAlignLeft.Name = "tbAlignLeft";
			this.tbAlignLeft.ToolTipText = "Align left";
			// 
			// tbAlignCenter
			// 
			this.tbAlignCenter.ImageIndex = 5;
			this.tbAlignCenter.Name = "tbAlignCenter";
			this.tbAlignCenter.ToolTipText = "Align center";
			// 
			// tbAlignRight
			// 
			this.tbAlignRight.ImageIndex = 9;
			this.tbAlignRight.Name = "tbAlignRight";
			this.tbAlignRight.ToolTipText = "Align right";
			// 
			// tbSep5
			// 
			this.tbSep5.Name = "tbSep5";
			this.tbSep5.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// tbSameWidth
			// 
			this.tbSameWidth.ImageIndex = 12;
			this.tbSameWidth.Name = "tbSameWidth";
			this.tbSameWidth.ToolTipText = "Same width";
			// 
			// tbSameHeight
			// 
			this.tbSameHeight.ImageIndex = 11;
			this.tbSameHeight.Name = "tbSameHeight";
			this.tbSameHeight.ToolTipText = "Same height";
			// 
			// tbSameBoth
			// 
			this.tbSameBoth.ImageIndex = 10;
			this.tbSameBoth.Name = "tbSameBoth";
			this.tbSameBoth.ToolTipText = "Same both";
			// 
			// mainToolBarImages
			// 
			this.mainToolBarImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("mainToolBarImages.ImageStream")));
			this.mainToolBarImages.TransparentColor = System.Drawing.Color.Magenta;
			this.mainToolBarImages.Images.SetKeyName(0, "");
			this.mainToolBarImages.Images.SetKeyName(1, "");
			this.mainToolBarImages.Images.SetKeyName(2, "");
			this.mainToolBarImages.Images.SetKeyName(3, "Run.BMP");
			this.mainToolBarImages.Images.SetKeyName(4, "");
			this.mainToolBarImages.Images.SetKeyName(5, "");
			this.mainToolBarImages.Images.SetKeyName(6, "");
			this.mainToolBarImages.Images.SetKeyName(7, "");
			this.mainToolBarImages.Images.SetKeyName(8, "");
			this.mainToolBarImages.Images.SetKeyName(9, "");
			this.mainToolBarImages.Images.SetKeyName(10, "");
			this.mainToolBarImages.Images.SetKeyName(11, "");
			this.mainToolBarImages.Images.SetKeyName(12, "");
			// 
			// designer1
			// 
			this.designer1.Active = false;
			this.designer1.DesignContainer = null;
			this.designer1.DesignedComponents = null;
			this.designer1.DesignedForm = null;
			this.designer1.FormTreasury = this.treasury1;
			this.designer1.GridSize = new System.Drawing.Size(8, 8);
			this.designer1.LoadMode = Greatis.FormDesigner.LoadModes.Duplicate;
			this.designer1.LogFile = null;
			this.designer1.ShowErrorMessage = true;
			this.designer1.ShowGrid = false;
			this.designer1.SnapToGrid = false;
			this.designer1.UseSmartTags = false;
			// 
			// treasury1
			// 
			this.treasury1.Components = null;
			this.treasury1.DesignerHost = null;
			this.treasury1.LoadMode = Greatis.FormDesigner.LoadModes.Duplicate;
			this.treasury1.LogFile = null;
			this.treasury1.ShowErrorMessage = true;
			// 
			// panelDesign
			// 
			this.panelDesign.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panelDesign.Location = new System.Drawing.Point(157, 28);
			this.panelDesign.Name = "panelDesign";
			this.panelDesign.Size = new System.Drawing.Size(430, 341);
			this.panelDesign.TabIndex = 6;
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(154, 28);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 341);
			this.splitter1.TabIndex = 4;
			this.splitter1.TabStop = false;
			// 
			// splitter2
			// 
			this.splitter2.Dock = System.Windows.Forms.DockStyle.Right;
			this.splitter2.Location = new System.Drawing.Point(587, 28);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(3, 341);
			this.splitter2.TabIndex = 5;
			this.splitter2.TabStop = false;
			// 
			// propertyGrid
			// 
			this.propertyGrid.Dock = System.Windows.Forms.DockStyle.Right;
			this.propertyGrid.Location = new System.Drawing.Point(590, 28);
			this.propertyGrid.Name = "propertyGrid";
			this.propertyGrid.Size = new System.Drawing.Size(148, 341);
			this.propertyGrid.TabIndex = 3;
			// 
			// toolboxControl
			// 
			this.toolboxControl.Designer = null;
			this.toolboxControl.Dock = System.Windows.Forms.DockStyle.Left;
			this.toolboxControl.Location = new System.Drawing.Point(0, 28);
			this.toolboxControl.Name = "toolboxControl";
			this.toolboxControl.SelectedCategory = null;
			this.toolboxControl.SelectedItem = null;
			this.toolboxControl.Size = new System.Drawing.Size(154, 341);
			this.toolboxControl.TabIndex = 2;
			// 
			// DesignerDemo
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(738, 369);
			this.Controls.Add(this.panelDesign);
			this.Controls.Add(this.splitter2);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.toolboxControl);
			this.Controls.Add(this.propertyGrid);
			this.Controls.Add(this.mainToolBar);
			this.Font = new System.Drawing.Font("Tahoma", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu;
			this.Name = "DesignerDemo";
			this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
			this.Text = "Greatis Form Designer .Net | Framework Style Demo";
			this.ResumeLayout(false);
			this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault(false);
			Application.Run(new MainForm());
		}

		private void miExitDesigner_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void miNewForm_Click(object sender, System.EventArgs e)
		{
			NewDesignedForm();
		}

		private void Init()
		{
			//Width = Screen.PrimaryScreen.Bounds.Width;
			//Height = mainToolBar.Height + SystemInformation.MenuHeight;

			// disable save button
			this.tbSaveForm.Enabled = false;

			// disable design button
			this.tbDesign.Enabled = false;

			InitToolbox();

			EnableAlignResize(false);
			miDeleteSelection.Enabled = false;
			miDesign.Enabled = false;

			miUndo.Enabled = false;
			miRedo.Enabled = false;
		}

		private void InitDesignerMenu()
		{
			IMenuCommandService mcs = (IMenuCommandService)designer1.DesignerHost.
			   GetService(typeof(IMenuCommandService));

			DesignerVerb dv = new DesignerVerb("Click me", new EventHandler(OnMenuCommand));
			mcs.AddVerb(dv);
		}

		private void OnMenuCommand(object sender, EventArgs e)
		{
			System.Windows.Forms.MessageBox.Show("Menu command has been invoked.");
		}

		private void InitToolbox()
		{
			toolboxControl.AddItem(new System.Drawing.Design.ToolboxItem(typeof(Button)), "General");
			toolboxControl.AddItem(new System.Drawing.Design.ToolboxItem(typeof(ListView)), "General");
			toolboxControl.AddItem(new System.Drawing.Design.ToolboxItem(typeof(TabControl)), "General");
			toolboxControl.AddItem(new System.Drawing.Design.ToolboxItem(typeof(TreeView)), "General");
			toolboxControl.AddItem(new System.Drawing.Design.ToolboxItem(typeof(TextBox)), "General");
			toolboxControl.AddItem(new System.Drawing.Design.ToolboxItem(typeof(Label)), "General");
			toolboxControl.AddItem(new System.Drawing.Design.ToolboxItem(typeof(Panel)), "Containers");
			toolboxControl.AddItem(new System.Drawing.Design.ToolboxItem(typeof(GroupBox)), "Containers");
			toolboxControl.AddItem(new System.Drawing.Design.ToolboxItem(typeof(DataGridView)), "Data");
			toolboxControl.AddItem(new System.Drawing.Design.ToolboxItem(typeof(Timer)), "Components");
		}

		private void Design()
		{
			if (designer1.Active == false)
				StartDesign();
			else
				EndDesign();
		}

		private void StartDesign()
		{
			designer1.DesignContainer = this.panelDesign;

			designer1.UseSmartTags = true;

			//propertyGrid.SelectedObject = designer1.DesignedForm;
			propertyGrid.Site = new PropertyGridSite(designer1.DesignerHost as IServiceProvider);

			if (toolboxControl.Designer == null)
				toolboxControl.Designer = designer1;

			ISelectionService ss = (ISelectionService)designer1.DesignerHost.GetService(typeof(ISelectionService));
			ss.SelectionChanged += new EventHandler(SelectionChanged);

			IComponentChangeService iccs = (IComponentChangeService)
			   designer1.DesignerHost.GetService(typeof(IComponentChangeService));
			iccs.ComponentAdded += new ComponentEventHandler(ComponentAdded);
			iccs.ComponentChanged += new ComponentChangedEventHandler(ComponentChanged);
			iccs.ComponentRemoved += new ComponentEventHandler(ComponentRemoved);

			designer1.KeyDown += new KeyEventHandler(DesignedForm_KeyDown);

			designer1.Active = true;

			EnableAlignResize(false);
			this.miDeleteSelection.Enabled = false;
		}

		private void EndDesign()
		{
			ISelectionService ss = (ISelectionService)designer1.DesignerHost.GetService(typeof(ISelectionService));
			ss.SelectionChanged -= new EventHandler(SelectionChanged);

			designer1.KeyDown -= new KeyEventHandler(DesignedForm_KeyDown);

			EnableAlignResize(false);
			this.miDeleteSelection.Enabled = false;

			CheckDesignedForm();

			designer1.Active = false;

			designer1.DesignContainer = null;

			if (DesignEnded != null)
				DesignEnded(this, new EventArgs());

			propertyGrid.Site = null;
		}

		internal event EventHandler DesignEnded;

		internal void SetDesignedForm(Control designedForm, IComponent[] designedComponents)
		{
			// assign designed form to designer
			designer1.DesignedForm = designedForm;
			designer1.DesignedComponents = designedComponents;

			// enable design button
			tbDesign.Enabled = true;
			miDesign.Enabled = true;
			tbSaveForm.Enabled = true;

			StartDesign();
		}

		private void NewDesignedForm()
		{
			if (designer1.DesignedForm == null)
			{
				// create new form
				Form designedForm = new Form();
				designedForm.Location = new Point(50, 100);
				designedForm.Size = new Size(640, 480);
				designedForm.Text = "Designed Form";
				designedForm.ShowInTaskbar = false;

				designedForm.KeyPreview = true;

				designedForm.Show();
				designedForm.Closing += new CancelEventHandler(DesignedFormClosing);

				// assign designed form to designer
				designer1.DesignedForm = designedForm;

				// enable design button
				tbDesign.Enabled = true;
				miDesign.Enabled = true;
				tbSaveForm.Enabled = true;
			}
		}

		private void SaveDesignedForm()
		{
			SaveFileDialog saveFileName = new SaveFileDialog();
			saveFileName.Filter = "XML text format (*.xml)|*.xml|Proprietary text format (*.*)|*.*";
			saveFileName.FilterIndex = 1;
			saveFileName.RestoreDirectory = true;

			if (saveFileName.ShowDialog() == DialogResult.OK)
			{
				if (saveFileName.FilterIndex == 1)
				{
					// reading the designing form layout into XML string
					string test = designer1.LayoutXML;

					TextWriter txtWriter = new StreamWriter(saveFileName.FileName);
					txtWriter.Write(test);
					txtWriter.Close();
				}
				else
					designer1.SaveToFile(saveFileName.FileName);
			}
		}

		private void OpenDesignedForm()
		{
			OpenFileDialog openFileName = new OpenFileDialog();

			openFileName.Filter = "XML text format (*.xml)|*.xml|Proprietary text format (*.*)|*.*";
			openFileName.FilterIndex = 1;
			openFileName.RestoreDirectory = true;

			if (openFileName.ShowDialog() == DialogResult.OK)
			{
				if (designer1.DesignedForm == null)
					NewDesignedForm();
				else if (designer1.Active == false)
				{
					Form designedForm = designer1.DesignedForm.FindForm();
					designer1.DesignedForm = null;
					designedForm.Dispose();

					NewDesignedForm();
				}
				if (openFileName.FilterIndex == 1)
				{
					TextReader txtReader = new StreamReader(openFileName.FileName);
					string layoutString = txtReader.ReadToEnd();

					txtReader.Close();

					designer1.LayoutXML = layoutString;
				}
				else
					designer1.LoadFromFile(openFileName.FileName);

				tbDesign.Enabled = true;
				miDesign.Enabled = true;
				tbSaveForm.Enabled = true;
			}
		}

		/// <summary>
		/// Show About dialog box
		/// </summary>
		private void ShowAbout()
		{
			MessageBox.Show("Greatis Form Designer for .Net" + Environment.NewLine +
			   "Framework Style Demo" + Environment.NewLine +
			   "Copyright  2004-2014 Greatis Software",
			   "About",
			   MessageBoxButtons.OK);
		}

		private void CheckDesignedForm()
		{
			if (designer1.IsDirty == true)
			{
				if (MessageBox.Show("Do you want save the designed form?", "Question",
				   MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
				{
					SaveDesignedForm();
				}
			}
		}

		protected override void OnClosing(CancelEventArgs e)
		{
			CheckDesignedForm();
			if (designer1.Active)
				EndDesign();
			else
				if (DesignEnded != null)
					DesignEnded(this, new EventArgs());
			base.OnClosing(e);
		}

		private void mainToolBar_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if (e.Button == this.tbNewForm)
				NewDesignedForm();
			else if (e.Button == this.tbDesign)
				Design();
			else if (e.Button == this.tbSaveForm)
				SaveDesignedForm();
			else if (e.Button == this.tbOpenForm)
				OpenDesignedForm();
			else if (e.Button == this.tbAlignBottom)
				designer1.Align(Greatis.FormDesigner.AlignType.Bottom);
			else if (e.Button == this.tbAlignCenter)
				designer1.Align(Greatis.FormDesigner.AlignType.Center);
			else if (e.Button == this.tbAlignTop)
				designer1.Align(Greatis.FormDesigner.AlignType.Top);
			else if (e.Button == this.tbAlignLeft)
				designer1.Align(Greatis.FormDesigner.AlignType.Left);
			else if (e.Button == this.tbAlignRight)
				designer1.Align(Greatis.FormDesigner.AlignType.Right);
			else if (e.Button == this.tbAlignMiddle)
				designer1.Align(Greatis.FormDesigner.AlignType.Middle);
			else if (e.Button == this.tbSameHeight)
				designer1.MakeSameSize(Greatis.FormDesigner.ResizeType.SameHeight);
			else if (e.Button == this.tbSameWidth)
				designer1.MakeSameSize(Greatis.FormDesigner.ResizeType.SameWidth);
			else if (e.Button == this.tbSameBoth)
				designer1.MakeSameSize(Greatis.FormDesigner.ResizeType.SameHeight |
				   Greatis.FormDesigner.ResizeType.SameWidth);
		}

		private void miDesign_Click(object sender, System.EventArgs e)
		{
			Design();
		}

		private void miAbout_Click(object sender, System.EventArgs e)
		{
			ShowAbout();
		}

		private void DesignedFormClosing(object sender, CancelEventArgs e)
		{
			EndDesign();
			tbDesign.Enabled = false;
		}

		private void miSaveForm_Click(object sender, System.EventArgs e)
		{
			SaveDesignedForm();
		}

		private void miOpenForm_Click(object sender, System.EventArgs e)
		{
			OpenDesignedForm();
		}

		private void EnableAlignResize(bool enable)
		{
			this.miAlignBottom.Enabled = enable;
			this.miAlignMiddle.Enabled = enable;
			this.miAlignTop.Enabled = enable;
			this.miAlignCenter.Enabled = enable;
			this.miAlignRight.Enabled = enable;
			this.miAlignLeft.Enabled = enable;

			this.tbAlignBottom.Enabled = enable;
			this.tbAlignMiddle.Enabled = enable;
			this.tbAlignTop.Enabled = enable;
			this.tbAlignCenter.Enabled = enable;
			this.tbAlignLeft.Enabled = enable;
			this.tbAlignRight.Enabled = enable;

			this.miSameBoth.Enabled = enable;
			this.miSameWidth.Enabled = enable;
			this.miSameHeight.Enabled = enable;

			this.tbSameBoth.Enabled = enable;
			this.tbSameWidth.Enabled = enable;
			this.tbSameHeight.Enabled = enable;
		}

		private void SelectionChanged(object sender, EventArgs e)
		{
			// disable/enable menu & toolbox align buttons
			int selectionCount = ((ISelectionService)sender).SelectionCount;
			bool enable = (selectionCount < 2) ? false : true;

			EnableAlignResize(enable);

			if (selectionCount >= 1)
			{
				this.miDeleteSelection.Enabled = true;
				this.miCopy.Enabled = true;
			}
			else
			{
				this.miDeleteSelection.Enabled = false;
				this.miCopy.Enabled = false;
			}
			if (selectionCount == 0)
				propertyGrid.SelectedObject = designer1.DesignedForm;
			else
			{
				object[] selected = new object[selectionCount];
				((ISelectionService)sender).GetSelectedComponents().CopyTo(selected, 0);
				propertyGrid.SelectedObjects = selected;
			}
		}

		private void miAlignTop_Click(object sender, System.EventArgs e)
		{
			designer1.Align(Greatis.FormDesigner.AlignType.Top);
		}

		private void miAlignMiddle_Click(object sender, System.EventArgs e)
		{
			designer1.Align(Greatis.FormDesigner.AlignType.Middle);
		}

		private void miAlignBottom_Click(object sender, System.EventArgs e)
		{
			designer1.Align(Greatis.FormDesigner.AlignType.Bottom);
		}

		private void miAlignLeft_Click(object sender, System.EventArgs e)
		{
			designer1.Align(Greatis.FormDesigner.AlignType.Left);
		}

		private void miAlignCenter_Click(object sender, System.EventArgs e)
		{
			designer1.Align(Greatis.FormDesigner.AlignType.Center);
		}

		private void miAlignRight_Click(object sender, System.EventArgs e)
		{
			designer1.Align(Greatis.FormDesigner.AlignType.Right);
		}

		private void miSameHeight_Click(object sender, System.EventArgs e)
		{
			designer1.MakeSameSize(Greatis.FormDesigner.ResizeType.SameHeight);
		}

		private void miSameWidth_Click(object sender, System.EventArgs e)
		{
			designer1.MakeSameSize(Greatis.FormDesigner.ResizeType.SameWidth);
		}

		private void miSameBoth_Click(object sender, System.EventArgs e)
		{
			designer1.MakeSameSize(Greatis.FormDesigner.ResizeType.SameHeight |
			   Greatis.FormDesigner.ResizeType.SameWidth);
		}

		private void miDeleteSelection_Click(object sender, System.EventArgs e)
		{
			designer1.DeleteSelected();
		}

		private void miCopy_Click(object sender, System.EventArgs e)
		{
			designer1.CopyControlsToClipboard();
		}

		private void miPaste_Click(object sender, System.EventArgs e)
		{
			designer1.PasteControlsFromClipboard();
		}

		private void DesignedForm_KeyDown(object sender, KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Delete)
				designer1.DeleteSelected();
			if (e.Shift == true && e.KeyCode == Keys.Insert)
				designer1.PasteControlsFromClipboard();
			if (e.Control == true && e.KeyCode == Keys.Insert)
				designer1.CopyControlsToClipboard();
		}

		private void miSaveXML_Click(object sender, System.EventArgs e)
		{
			SaveFileDialog saveFileName = new SaveFileDialog();
			saveFileName.Filter = "XML Form (*.xml)|*.xml|All files (*.*)|*.*";
			saveFileName.FilterIndex = 1;
			saveFileName.RestoreDirectory = true;

			if (saveFileName.ShowDialog() == DialogResult.OK)
			{
				// reading the designing form layout into XML string
				string test = designer1.LayoutXML;

				TextWriter txtWriter = new StreamWriter(saveFileName.FileName);
				txtWriter.Write(test);
				txtWriter.Close();

				//XmlWriter writer = new XmlTextWriter(saveFileName.FileName, null);
				//designer1.Store(ref writer);
				//writer.Close();
			}
		}

		private void miOpenXML_Click(object sender, System.EventArgs e)
		{
			OpenDesignedForm();
		}

		private void miUndo_Click(object sender, System.EventArgs e)
		{
			designer1.Undo();
			miUndo.Enabled = (designer1.UndoCount != 0);
			miRedo.Enabled = (designer1.RedoCount != 0);
		}

		private void miRedo_Click(object sender, System.EventArgs e)
		{
			designer1.Redo();
			miUndo.Enabled = (designer1.UndoCount != 0);
			miRedo.Enabled = (designer1.RedoCount != 0);
		}

		private void ComponentAdded(object sender, ComponentEventArgs e)
		{
			miUndo.Enabled = (designer1.UndoCount != 0);
			miRedo.Enabled = (designer1.RedoCount != 0);
		}

		private void ComponentChanged(object sender, ComponentChangedEventArgs e)
		{
			miUndo.Enabled = (designer1.UndoCount != 0);
			miRedo.Enabled = (designer1.RedoCount != 0);
		}

		private void ComponentRemoved(object sender, ComponentEventArgs e)
		{
			miUndo.Enabled = (designer1.UndoCount != 0);
			miRedo.Enabled = (designer1.RedoCount != 0);
		}

		private void button1_Click(object sender, EventArgs e)
		{
			IMenuCommandService mcs = (IMenuCommandService)designer1.DesignerHost.
			GetService(typeof(IMenuCommandService));
			mcs.GlobalInvoke(StandardCommands.Copy);
		}

		private void button2_Click(object sender, EventArgs e)
		{
			IMenuCommandService mcs = (IMenuCommandService)designer1.DesignerHost.
				  GetService(typeof(IMenuCommandService));
			mcs.GlobalInvoke(StandardCommands.Paste);
		}
	}

	/// A nearly empty implementation of ISite, this class merely passes on
	/// service requests to the host.
	internal class PropertyGridSite : System.ComponentModel.ISite
	{
		private IServiceProvider sp;

		public PropertyGridSite(IServiceProvider sp)
		{
			this.sp = sp;
		}

		#region Implementation of ISite

		public System.ComponentModel.IComponent Component
		{
			get { return null; }
		}

		public System.ComponentModel.IContainer Container
		{
			get { return null; }
		}

		public bool DesignMode
		{
			get { return false; }
		}

		public string Name
		{
			get { return null; }
			set { }
		}

		#endregion

		#region Implementation of IServiceProvider

		public object GetService(Type serviceType)
		{
			if (sp != null)
				return sp.GetService(serviceType);

			return null;
		}

		#endregion
	}
}
